//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "FRB.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cspin"
#pragma resource "*.dfm"

Word wInitialCode, wTotalBoards,wPort,wSAn,wRAn ;
Word wDoVal, wRtn;

TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{

    if (Button1->Caption == "Active")
    {
        wRtn = FRB_ActiveBoard( (WORD) StrToInt( eSelect->Text ) );
        if ( wRtn != FRB_NoError ) {
            ShowMessage( "Active Board Error!!\nError Code:" + IntToStr(wRtn) );
            return;
        }
        CheckBox1Click( CheckBox1 );
        CheckBox1Click( CheckBox1 );
        Button1->Caption   = "Stop";
        Button2->Enabled   = False;
        Timer1->Enabled    = True;
        GroupBox1->Enabled = True;
        ePort->Enabled = False;
        eSA->Enabled = False;
        eRA->Enabled = False;
    }
    else
    {
        Button1->Caption   = "Active";
        Button2->Enabled   = True;
        Timer1->Enabled    = False;
        GroupBox1->Enabled = False;
        ePort->Enabled = True;
        eSA->Enabled = True;
        eRA->Enabled = True;
    };



}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
    //********************************************************************
    //* NOTICE: call A823_DriverInit() to initialize the driver.        *
    //********************************************************************

    wInitialCode = FRB_DriverInit( &wTotalBoards );
    Button1->Caption = "Active";
    if ( wInitialCode != FRB_NoError )
    {
        ShowMessage( "FRB-100/200 device driver Open Error!!") ;
        Button1->Enabled = False;
    }
    else {
        eTotal->Text = IntToStr( wTotalBoards );
        Button1->Enabled = True;
        wPort =(WORD)StrToInt(ePort->Text);
        wSAn = (WORD)StrToInt(eSA->Text);
        wRAn = (WORD)StrToInt(eRA->Text);
    }








}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
      Timer1->Enabled = False;
      FRB_DriverClose();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{
    if ( ((TCheckBox*)Sender)->Checked )
       wDoVal = wDoVal | (Word)(1 << ((TCheckBox*)Sender)->Tag);
    else
       wDoVal = wDoVal & (Word)( ~(1 << ((TCheckBox*)Sender)->Tag));

    wRtn = FRB_SendSA(wPort, wSAn,wDoVal) ;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
   WORD i, wDiVal;

   wRtn = FRB_ReceiveRA(wPort, wRAn, &wDiVal);
   for (i=0;i<16;i++)
        if (( wDiVal & (1 << i)) != 0)
            ((TShape*)(FindComponent("spIn" + IntToHex(i,2))))->Brush->Color = clRed;
        else
            ((TShape*)(FindComponent("spIn" + IntToHex(i,2))))->Brush->Color = clBlack;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
    Close();    
}
//---------------------------------------------------------------------------


void __fastcall TForm1::ePortClick(TObject *Sender)
{
  wPort =(WORD) StrToInt(ePort->Text);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::eSAClick(TObject *Sender)
{
   wSAn =(WORD) StrToInt(eSA->Text);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::eRAClick(TObject *Sender)
{
     wRAn =(WORD) StrToInt(eRA->Text);
}
//---------------------------------------------------------------------------

